security:
    enable_authenticator_manager: true
    hide_user_not_found: false
    # https://symfony.com/doc/current/security.html#registering-the-user-hashing-passwords
    password_hashers:
        Symfony\Component\Security\Core\User\PasswordAuthenticatedUserInterface: 'auto'
    role_hierarchy:
        ROLE_ADMIN: [ROLE_USER]
    # https://symfony.com/doc/current/security.html#loading-the-user-the-user-provider
    providers:
        in_memory:
            memory:
                users:
                    admin:
                        password: '$2y$13$FeXe7DfR/a4X7eyrB8.o6.xKXcrPt.82JzqNbFwM0JpC2dFzIT3gS'
                        roles: 'ROLE_ADMIN'
        users_in_memory: { memory: null }
    firewalls:
        dev:
            pattern: ^/(_(profiler|wdt)|css|images|js)/
            security: false
        main:
            lazy: true
            pattern: ^/
            provider: in_memory
            form_login:
                login_path: app_login
                check_path: app_login
            logout:
                path: app_logout
                target: app_answer_index

            # activate different ways to authenticate
            # https://symfony.com/doc/current/security.html#the-firewall

            # https://symfony.com/doc/current/security/impersonating_user.html
            # switch_user: true

    # Easy way to control access for large sections of your site
    # Note: Only the *first* access control that matches will be used
    access_control:
        - { path: ^/, role: PUBLIC_ACCESS }
        - { path: ^/admin, roles: ROLE_ADMIN }

when@test:
    security:
        password_hashers:
            # By default, password hashers are resource intensive and take time. This is
            # important to generate secure password hashes. In tests however, secure hashes
            # are not important, waste resources and increase test times. The following
            # reduces the work factor to the lowest possible values.
            Symfony\Component\Security\Core\User\PasswordAuthenticatedUserInterface:
                algorithm: auto
                cost: 4 # Lowest possible value for bcrypt
                time_cost: 3 # Lowest possible value for argon
                memory_cost: 10 # Lowest possible value for argon
